# Flow and Cut
*LightGraphs.jl* provides different algorithms for [maximum flow](https://en.wikipedia.org/wiki/Maximum_flow_problem)
and minimum cut computations, including:

```@index
Order = [:type, :function]
Pages   = ["flowcut.md"]
```

## Full Docs

```@autodocs
Modules = [LightGraphs]
Pages   = [ "flow/boykov_kolmogorov.jl",
            "flow/dinic.jl",
            "flow/edmonds_karp.jl",
            "flow/ext_multiroute_flow.jl",
            "flow/kishimoto",
            "flow/maximum_flow.jl",
            "flow/multiroute_flow.jl",
            "flow/push_relabel.jl"
            ]
Private = false
```
